unit UVB0404GSM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, voicerlibLib_TLB, ShellApi, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    btnShutDownVoicerlib: TButton;                           
    btnStartVoicerLib: TButton;
    vlib: Tvoicerlib;
    btnCriaThread: TButton;
    btnDestroiThread: TButton;
    GroupBox2: TGroupBox;
    memStatus: TMemo;
    btnLimparLog: TButton;
    Label4: TLabel;
    txtPortaFiltro: TEdit;
    GroupBox3: TGroupBox;
    btnAtender: TButton;
    btnDesligar: TButton;
    Label2: TLabel;
    txtPorta: TEdit;
    Label1: TLabel;
    txtNumero: TEdit;
    btnSignal: TButton;
    txtSignal: TEdit;
    Label3: TLabel;
    btnConfigurar: TButton;
    btnDiscar: TButton;
    btnEnviarSMS: TButton;
    LeiaMe: TButton;
    memMensagem: TMemo;
    btnReproduzArquivo: TButton;
    btnIniciaGravacao: TButton;
    txtArquivo: TEdit;
    btnParaGravacao: TButton;
    Label5: TLabel;
    GroupBox4: TGroupBox;
    btnApagarTodosSMS: TButton;
    btnListaSMS: TButton;
    btnApagarSMS: TButton;
    txtIndiceMgs: TEdit;
    Label6: TLabel;
    btnLerSMS: TButton;
    btnRestartar: TButton;
    btnColocaEmEspera: TButton;
    btnConferencia: TButton;
    btnDesligaTodas: TButton;
    btnListaQtdeSMS: TButton;
    GroupBox5: TGroupBox;
    rbSim: TRadioButton;
    rbNao: TRadioButton;
    rbIgnora: TRadioButton;
    Image1: TImage;
    procedure btnStartVoicerLibClick(Sender: TObject);
    procedure btnShutDownVoicerlibClick(Sender: TObject);
    procedure btnCriaThreadClick(Sender: TObject);
    procedure btnDestroiThreadClick(Sender: TObject);
    procedure vlibGSMMessage(ASender: TObject; Port, State: Smallint);
    procedure vlibGSMReady(ASender: TObject; Port, State: Smallint);
    procedure vlibGSMError(ASender: TObject; Port, State: Smallint);
    procedure vlibGSMSMSReceived(ASender: TObject; Port: Smallint);
    procedure vlibGSMSMSSent(ASender: TObject; Port: Smallint);
    procedure vlibGSMTimeout(ASender: TObject; Port, State: Smallint);
    procedure btnLimparLogClick(Sender: TObject);
    procedure btnDiscarClick(Sender: TObject);
    procedure vlibAfterDial(ASender: TObject; Port: Smallint);
    procedure btnEnviarSMSClick(Sender: TObject);
    procedure btnDesligarClick(Sender: TObject);
    procedure vlibCallerID(ASender: TObject; Port: Smallint;
      const Number: WideString);
    procedure vlibRingDetected(ASender: TObject; Port: Smallint);
    procedure vlibCalling(ASender: TObject; Port: Smallint);
    procedure btnSignalClick(Sender: TObject);
    procedure vlibGSMSignalQuality(ASender: TObject; Port: Smallint);
    procedure btnConfigurarClick(Sender: TObject);
    procedure LeiaMeClick(Sender: TObject);
    procedure btnIniciaGravacaoClick(Sender: TObject);
    procedure vlibRecording(ASender: TObject; Port: Smallint;
      ElapsedTime: Integer);
    procedure btnParaGravacaoClick(Sender: TObject);
    procedure btnReproduzArquivoClick(Sender: TObject);
    procedure vlibRecordStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure vlibPlayStop(ASender: TObject; Port, StopStatus: Smallint);
    procedure btnAtenderClick(Sender: TObject);
    procedure btnLerSMSClick(Sender: TObject);
    procedure btnRestartarClick(Sender: TObject);
    procedure btnApagarSMSClick(Sender: TObject);
    procedure btnApagarTodosSMSClick(Sender: TObject);
    procedure btnListaSMSClick(Sender: TObject);
    procedure vlibGSMReturnOK(ASender: TObject; Port, State: Smallint);
    procedure btnColocaEmEsperaClick(Sender: TObject);
    procedure btnConferenciaClick(Sender: TObject);
    procedure btnDesligaTodasClick(Sender: TObject);
    procedure vlibGSMOtherCall(ASender: TObject; Port: Smallint);
    procedure btnListaQtdeSMSClick(Sender: TObject);
    procedure vlibGSMMemory(ASender: TObject; Port: Smallint);
    procedure vlibGSMMemoryFull(ASender: TObject; Port: Smallint);
    procedure rbSimClick(Sender: TObject);
    procedure rbNaoClick(Sender: TObject);
    procedure rbIgnoraClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  MAXCANAIS = 4;

var
  Form1: TForm1;
  sReturnGSM : array [0..255] of Char;
  sReturn    : array [0..255] of Char;
  nFlagReady : array [1..MAXCANAIS] of Integer;
  nRestricao : Integer;
  cVersao : array[0..255] of Char;

implementation

{$R *.dfm}

procedure MostraStatus(nPorta: integer; sMess: string);
var
  sMsg: string;
begin

  if Trim(Form1.txtPortaFiltro.Text) <> '' then
    if not (nPorta = StrToInt(Form1.txtPortaFiltro.Text)) then
      Exit;

  if ( nPorta > 0 ) then
  begin
    sMsg := '<'+TimeToStr(Time)+'>'+'(Porta '+IntToStr(nPorta)+') '+sMess;
  end
  else
  begin
    sMsg := '<'+TimeToStr(Time)+'>'+sMess;
  end;

  Form1.memStatus.Lines.Add(sMsg);
end;

procedure TForm1.btnStartVoicerLibClick(Sender: TObject);
var
  nRet : Integer;
begin

  //Inicializa a voicerlib
  nRet := vlib.StartVoicerLib;

  //Trata o retorno da inicializacao
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(0,'StartVoicerLib - ' + sReturn);

  nRet := vlib.GetVersion(1);
  MostraStatus(0,'Firmware Version - ' + IntToHex(nRet,2));

  btnEnviarSMS.Enabled := True;
  
end;

procedure TForm1.btnShutDownVoicerlibClick(Sender: TObject);
var
  nRet : Integer;
begin
  //Finaliza a voicerlib
  nRet := vlib.ShutdownVoicerLib;

  //Trata o retorno da finalizacao
  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(0,'ShutdownVoicerLib - ' + sReturn);

end;

procedure TForm1.btnCriaThreadClick(Sender: TObject);
var
  nRet,i : Integer;
begin

  for i:=1 to (vlib.GetPortsCount) do
  begin
    //vlib.GSMSetPinNumber(i,'9999','');

    nFlagReady[i] := 0;
    
    //Criar thread gsm
    nRet := vlib.CreateGSMThread(i);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'CreateGSMThread - ' + sReturn);
      Exit;
    end;

    //Cria thread de supervisao de linha
    nRet := vlib.CreateCallProgress(i,'cp_default.cfg');
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'CreateCallProgress - ' + sReturn);
      Exit;
    end;

    //Especifica o formato de gravacao
    nRet := vlib.SetRecordFormat(i,ffWaveULaw);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'SetRecordFormat - ' + sReturn);
      Exit;
    end;

    //Especifica o formato de reproducao
    nRet := vlib.SetPlayFormat(i,ffWaveULaw);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'SetPlayFormat - ' + sReturn);
      Exit;
    end;

    //Habilita o envio de amostras da placa para a aplicacao
    nRet := vlib.EnableInputBuffer(i,DG_ENABLE);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'EnableInputBuffer - ' + sReturn);
      Exit;
    end;
  end;

  MostraStatus(0,'Threads GSM criadas com sucesso');
  MostraStatus(0,'Threads de callprogress criadas com sucesso');

end;

procedure TForm1.btnDestroiThreadClick(Sender: TObject);
var
  nRet,i: Integer;
begin

  for i:=1 to vlib.GetPortsCount do
  begin
    //Destroi thread de supervisao de linha
    nRet := vlib.DestroyCallProgress(i);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'DestroyCallProgress - ' + sReturn);
      Exit;
    end;

    //Destroi thread GSM
    nRet := vlib.DestroyGSMThread(i);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'DestroyGSMThread - ' + sReturn);
      Exit;
    end;

    //Desabilita a thread de input buffer
    nRet := vlib.DisableInputBuffer(i);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(i,'DisableInputBuffer - ' + sReturn);
      Exit;
    end;
  end;

  btnEnviarSMS.Enabled := True;
  
  MostraStatus(0,'Threads de callprogress destruidas com sucesso');
  MostraStatus(0,'Threads GSM destruidas com sucesso');

end;

procedure TForm1.vlibGSMMessage(ASender: TObject; Port, State: Smallint);
var
  sMensagem : array[0..255] of Char;
  sCommand : array[0..255] of Char;
  nRet : Integer;
begin

  //Mostra o ultimo comando enviado para placa
  nRet := vlib.GSMGetLastCommand(Port, cardinal(@sCommand));
  if nRet <> DG_EXIT_SUCCESS then
  begin
    vlib.ReturnCodeGSMToString(nRet,Cardinal(@sReturnGSM));
    MostraStatus(Port,'GSMGetLastMessage - ' + sReturnGSM);
  end;
  MostraStatus(Port, 'GSMGetLastCommand - ' + sCommand);

  //Recupera a mensagem
  nRet := vlib.GSMGetMessage(Port,cardinal(@sMensagem));
  if nRet <> DG_EXIT_SUCCESS then
  begin
    vlib.ReturnCodeGSMToString(nRet,Cardinal(@sReturnGSM));
    MostraStatus(Port,'GSMGetMessage - ' + sReturnGSM);
  end;
  MostraStatus(Port, 'GSMGetMessage - ' + sMensagem);

end;

procedure TForm1.vlibGSMReady(ASender: TObject; Port, State: Smallint);
begin

  if State = 1 then
  begin
    MostraStatus(Port,'Canal PRONTO para ser usado');
    nFlagReady[Port] := 1;
  end
  else
    MostraStatus(Port,'PROBLEMA na inicializao do canal');
end;

procedure TForm1.vlibGSMError(ASender: TObject; Port, State: Smallint);
begin
  MostraStatus(Port,'GSMError -> State ' + IntToStr(State));
  vlib.GSMCheckSignalQuality(Port);

end;

procedure TForm1.vlibGSMSMSReceived(ASender: TObject; Port: Smallint);
var
  sMensagem : array[0..255] of Char;
  nRet : Integer;
begin

  nRet := vlib.GSMGetSMS(Port,cardinal(@sMensagem));
  if nRet <> DG_EXIT_SUCCESS then
  begin
    vlib.ReturnCodeGSMToString(nRet,Cardinal(@sReturnGSM));
    MostraStatus(Port,'GSMGetSMS' + sReturnGSM);
  end;

  MostraStatus(Port,'GSMSMS -> State ' + sMensagem);
  
end;

procedure TForm1.vlibGSMSMSSent(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'GSMSMSSent...');
  btnEnviarSMS.Enabled := True;
end;

procedure TForm1.vlibGSMTimeout(ASender: TObject; Port, State: Smallint);
begin
  MostraStatus(Port,'GSMTimeout -> State ' + IntToStr(State));
  vlib.GSMCheckSignalQuality(Port);
end;

procedure TForm1.btnLimparLogClick(Sender: TObject);
begin
  memStatus.Clear;
end;

procedure TForm1.btnDiscarClick(Sender: TObject);
var
  nRet: Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Efetua discagem
    nRet := vlib.Dial(StrToInt(txtPorta.Text),txtNumero.Text,100,dtTone);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.text),'Dial -' + sReturn);
    end;
  end;  
end;

procedure TForm1.vlibAfterDial(ASender: TObject; Port: Smallint);
var
  nRet: Integer;
begin

  MostraStatus(Port,'Discou com sucesso');
  //Habilita supervisao de linha
  nRet := vlib.EnableCallProgress(Port,CP_ENABLE_ALL);
  if nRet <> DG_EXIT_SUCCESS then
  begin
    vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
    MostraStatus(Port,'EnableCallProgress - ' + sReturn);
  end;
  
end;

procedure TForm1.btnEnviarSMSClick(Sender: TObject);
var
  nRet,i:Integer;
  sMensagem: String;

begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    if txtNumero.Text = '' then
    begin
      MostraStatus(StrToInt(txtPorta.text),'Insira um nmero');
      Exit;
    end;

    if memMensagem.Lines[0] = '' then
    begin
      MostraStatus(StrToInt(txtPorta.text),'Insira uma mensagem');
      Exit;
    end;

    btnEnviarSMS.Enabled := False;

    for i:=0 to memMensagem.Lines.Count do
    begin
      sMensagem := sMensagem + memMensagem.Lines[i];
    end;

    nRet := vlib.GSMSendSMS(StrToInt(txtPorta.Text),txtNumero.Text,sMensagem);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeGSMToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMSendSMS - ' + sReturn);
      btnEnviarSMS.Enabled := True;
      Exit;
    end;
  end;
end;

procedure TForm1.btnDesligarClick(Sender: TObject);
var
  nRet:Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Desliga o canal
    nRet := vlib.HangUp(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'Hangup - ' + sReturn);
    end;

    //Desabilita supervisao de linha
    nRet := vlib.DisableCallProgress(StrToint(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'DisableCallProgress - ' + sReturn);
    end;
  end;
end;

procedure TForm1.vlibCallerID(ASender: TObject; Port: Smallint;
  const Number: WideString);
begin
  MostraStatus(Port, 'CallerID: ' + Number);
end;

procedure TForm1.vlibRingDetected(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port, 'Ring....');
end;

procedure TForm1.vlibCalling(ASender: TObject; Port: Smallint);
begin
  MostraStatus(Port,'Chamando....');
end;

procedure TForm1.btnSignalClick(Sender: TObject);
var
  nRet : Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Checa a qualidade do sinal
    nRet := vlib.GSMCheckSignalQuality(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMCheckSignalQuality - ' + sReturn);
    end;
  end;  
end;

procedure TForm1.vlibGSMSignalQuality(ASender: TObject; Port: Smallint);
var
  sMensagem : array[0..255] of Char;
  nRet : Integer;
  x : Variant;
begin

  //Recupera o valor respectivo a qualidade do sinal
  nRet := vlib.GSMGetSignalQuality(Port,cardinal(@sMensagem));
  if nRet <> DG_EXIT_SUCCESS then
  begin
    vlib.ReturnCodeGSMToString(nRet,Cardinal(@sReturnGSM));
    MostraStatus(Port,'GSMGetSignalQuality - ' + sReturnGSM);
  end;

  x := -113 + (2* StrToInt(sMensagem));

  txtSignal.Text := IntToStr(x);

end;

procedure TForm1.btnConfigurarClick(Sender: TObject);
var
  nRet : integer;
begin

  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin

    if rbSim.checked then
      nRestricao := 1
    else
      if rbNao.Checked then
        nRestricao := 0
      else
        nRestricao := 2;

    //Desabilita thread GSM
    nRet := vlib.DisableGSMThread(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'DisableGSMThread - ' + sReturn);
    end;

    //Configura thread GSM
    nRet := vlib.ConfigGSMThread(StrToInt(txtPorta.Text),GSMCFG_ID_RESTRICTION,nRestricao);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'ConfigGSMThread - ' + sReturn);
    end;

    //Habilita thread GSM
    nRet := vlib.EnableGSMThread(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'EnableGSMThread - ' + sReturn);
    end;
  end;
end;

procedure TForm1.LeiaMeClick(Sender: TObject);
var
  L: String;
begin
  L:= ExtractFilePath(Application.ExeName) + 'Leiame.txt' ;
  ShellExecute(0, nil ,PChar(L), nil,nil,SW_NORMAL);

end;

procedure TForm1.btnIniciaGravacaoClick(Sender: TObject);
var
  nRet : Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Inicia gravacao de recado
    nRet := vlib.RecordFile(StrToInt(txtPorta.Text) ,txtArquivo.Text,'');
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'RecordFile - ' + sReturn);
    end;
  end;  
end;

procedure TForm1.vlibRecording(ASender: TObject; Port: Smallint;
  ElapsedTime: Integer);
begin
  MostraStatus(Port,'Gravando....');
end;

procedure TForm1.btnParaGravacaoClick(Sender: TObject);
var
  nRet : Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Para a gravacao do arquivo
    nRet := vlib.StopRecordFile(StrToInt(txtPorta.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'StopRecordFile - ' + sReturn);
    end;
  end;  
end;

procedure TForm1.btnReproduzArquivoClick(Sender: TObject);
var
  nRet : integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Reproduz arquivo de audio
    nRet := vlib.PlayFile(StrToInt(txtPorta.Text),txtArquivo.Text,'',0);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'PlayFile - ' + sReturn);
    end;
  end;
end;
procedure TForm1.vlibRecordStop(ASender: TObject; Port,
  StopStatus: Smallint);
begin
  MostraStatus(Port,'Encerrou gravao com sucesso');
end;

procedure TForm1.vlibPlayStop(ASender: TObject; Port,
  StopStatus: Smallint);
begin
  MostraStatus(Port,'Encerrou reproduo com sucesso');
end;

procedure TForm1.btnAtenderClick(Sender: TObject);
var
  nRet : Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Atende o canal
    nRet := vlib.Pickup(StrToInt(txtPorta.Text),100);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'Pickup - ' + sReturn);
    end;
  end;
end;

procedure TForm1.btnLerSMSClick(Sender: TObject);
var
  nRet : Integer;
begin

  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Le e deleta a mensagem
    nRet := vlib.GSMReadAndDeleteSMS(StrToInt(txtPorta.text),StrToInt(txtIndiceMgs.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMReadAndDelete - ' + sReturn);
    end;
  end;
end;

procedure TForm1.btnRestartarClick(Sender: TObject);
var
  nRet : Integer;
begin
  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Restarta a porta especificada
    nRet := vlib.GSMRestartPort(StrToInt(txtPorta.text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMRestartPort - ' + sReturn);
    end;
  end;
end;

procedure TForm1.btnApagarSMSClick(Sender: TObject);
var
  nRet : Integer;
begin

  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Deleta a mensagem correspondente ao index indicado
    nRet := vlib.GSMDeleteSMS(StrToInt(txtPorta.text),StrToInt(txtIndiceMgs.Text));
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMDeleteSMS - ' + sReturn);
    end;
  end;
end;

procedure TForm1.btnApagarTodosSMSClick(Sender: TObject);
var
  nRet : Integer;
begin

  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    //Apaga todas as mensagens correspondentes a porta especificada
    nRet := vlib.GSMClearAllSMS(StrToInt(txtPorta.text),1);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMClearAllSMS - ' + sReturn);
    end;
  end;
end;

procedure TForm1.btnListaSMSClick(Sender: TObject);
var
  nRet : Integer;
  sMensagem : array[0..255] of Char;
begin

  if nFlagReady[StrToInt(txtPorta.Text)] = 0 then
  begin
    MostraStatus(StrToInt(txtPorta.Text),' -> indisponivel - Evento OnGSMReady no gerado com sucesso para a porta especificada');
    Exit;
  end
  else
  begin
    nRet := vlib.GSMListSMS(StrToInt(txtPorta.text),ALL);
    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMListSMS - ' + sReturn);
    end
    else
      MostraStatus(StrToInt(txtPorta.Text),'GSMListSMS - ' + sMensagem);
  end;
end;

procedure TForm1.vlibGSMReturnOK(ASender: TObject; Port, State: Smallint);
var
  nRet:Integer;
  sMensagem : array[0..255] of Char;
begin
  if State = GSM_LIST then
  begin
    nRet := vlib.GSMGetIndexList(Port,Cardinal(@sMensagem));

    if nRet <> DG_EXIT_SUCCESS then
    begin
      vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
      MostraStatus(StrToInt(txtPorta.Text),'GSMGetIndexListSMS - ' + sReturn);
    end
    else
      MostraStatus(Port,'OnGSMMessage -> State ' + sMensagem);

  end;
end;

procedure TForm1.btnColocaEmEsperaClick(Sender: TObject);
var
  nRet : Integer;
begin

  nRet := vlib.GSMCallControl(StrToInt(txtPorta.Text),GSM_PUT_ON_HOLD,0);

  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(StrToInt(txtPorta.Text),'GSMCallControl - ' + sReturn);

end;

procedure TForm1.btnConferenciaClick(Sender: TObject);
var
  nRet : Integer;
begin

  nRet := vlib.GSMCallControl(StrToInt(txtPorta.Text),GSM_CONFERENCE,0);

  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(StrToInt(txtPorta.Text),'GSMCallControl - ' + sReturn);

end;

procedure TForm1.btnDesligaTodasClick(Sender: TObject);
var
  nRet : Integer;
begin

  nRet := vlib.GSMCallControl(StrToInt(txtPorta.Text),GSM_TERMINATE_AND_ACCEPT,0);

  vlib.ReturnCodeToString(nRet,Cardinal(@sReturn));
  MostraStatus(StrToInt(txtPorta.Text),'GSMCallControl - ' + sReturn);


end;

procedure TForm1.vlibGSMOtherCall(ASender: TObject; Port: Smallint);
var
  sNumero: String;
begin
  sNumero := vlib.GetCallerID(Port);
  MostraStatus(Port,'OnGSMOtherCall..CallerID ->>' + sNumero);
end;

procedure TForm1.btnListaQtdeSMSClick(Sender: TObject);
var
  i: Integer;
begin
  
  for i:=1 to vlib.GetPortsCount do
    vlib.GSMClearAllSMS(i,0); 
end;

procedure TForm1.vlibGSMMemory(ASender: TObject; Port: Smallint);
var
  sMensagem : array[0..255] of Char;
begin

  vlib.GSMGetMemory(Port, Cardinal(@sMensagem));
  MostraStatus(port,'GSM Memory-> ' + sMensagem); 

end;

procedure TForm1.vlibGSMMemoryFull(ASender: TObject; Port: Smallint);
begin
  ShowMessage('Porta ' + IntToStr(Port) + ' com memria cheia') ;
end;

procedure TForm1.rbSimClick(Sender: TObject);
begin
  if rbSim.Checked then
    nRestricao := 1;
   
end;

procedure TForm1.rbNaoClick(Sender: TObject);
begin
  if rbNao.Checked then
    nRestricao := 0;
end;

procedure TForm1.rbIgnoraClick(Sender: TObject);
begin
  if rbIgnora.Checked then
    nRestricao := 2;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  txtArquivo.Text := ExtractFilePath(Application.ExeName) + 'teste.wav';  
end;

procedure TForm1.FormCreate(Sender: TObject);
var   
  nRet : Integer; 
  cVersao : array[0..255] of Char;
begin
  //Verifica a versao da dll e ocx da voicerlib
  nRet := vlib.GetLibVersion(Cardinal(@cVersao),0);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso DLL -> ' + cVersao)
  else
    MostraStatus(0,'Verso DLL -> Falha');

  nRet := vlib.GetLibVersion(Cardinal(@cVersao),1);
  if nRet = DG_EXIT_SUCCESS then
    MostraStatus(0,'Verso OCX -> ' + cVersao)
  else
    MostraStatus(0,'Verso OCX -> Falha');
end;

end.
